#ifndef LIB_ERRDEFINITIONS_MQH_INCLUDED
#define LIB_ERRDEFINITIONS_MQH_INCLUDED
/**********************************************************************************
 * Copyright (C) 2010-2022 Dominik Egert <info@freie-netze.de>
 *
 * This file is error code MQL definitions include file.
 *
 * MQLplus, including this file may not be copied and/or distributed 
 * without explecit permit by the author.
 * Author Dominik Egert / Freie Netze UG.
 **********************************************************************************
 *
 *  Version: 4.2
 *  State: public
 *
 *  File information
 *  ================
 *
 *
 *  Use: resolve error codes to text.
 *
 *      Content is provided as is. All text
 *      and definitions have been extracted from
 *      https://docs.mql4.com/constants/errorswarnings/errorcodes
 *
 *      Feel free to edit or add any new codes
 *
 * 	Date of update: 15. April 2022
*/




/////////////////////////////////////////////////////////////////////
//
//  MQL API defined error codes
//  and descriptions.
//
//  Sadly some of the official defined error
//  codes are missing somehow. Therefore we
//  define them here.
//


/////////////////////////////////////////////////////////////////////
//
// General
//
#ifndef ERR_SUCCESS
    #define ERR_SUCCESS                                     0
#endif
#ifndef ERR_NO_ERROR                                	
	#define ERR_NO_ERROR                                	0               
#endif                                                                      
#ifndef ERR_NO_RESULT                               	
	#define ERR_NO_RESULT                               	1               
#endif                                                                      
#ifndef ERR_COMMON_ERROR                            	
	#define ERR_COMMON_ERROR                            	2               
#endif                                                                      
#ifndef ERR_INVALID_TRADE_PARAMETERS                	
	#define ERR_INVALID_TRADE_PARAMETERS                	3               
#endif                                                                      
#ifndef ERR_SERVER_BUSY                             	
	#define ERR_SERVER_BUSY                             	4               
#endif                                                                      
#ifndef ERR_OLD_VERSION                             	
	#define ERR_OLD_VERSION                             	5               
#endif                                                                      
#ifndef ERR_NO_CONNECTION                           	
	#define ERR_NO_CONNECTION                           	6               
#endif                                                                      
#ifndef ERR_NOT_ENOUGH_RIGHTS                       	
	#define ERR_NOT_ENOUGH_RIGHTS                       	7               
#endif                                                                      
#ifndef ERR_TOO_FREQUENT_REQUESTS                   	
	#define ERR_TOO_FREQUENT_REQUESTS                   	8               
#endif                                                                      
#ifndef ERR_MALFUNCTIONAL_TRADE                     	
	#define ERR_MALFUNCTIONAL_TRADE                     	9               
#endif                                                                      
#ifndef ERR_ACCOUNT_DISABLED                            
	#define ERR_ACCOUNT_DISABLED                            64              
#endif                                                                      
#ifndef ERR_INVALID_ACCOUNT                             
	#define ERR_INVALID_ACCOUNT                             65              
#endif                                                                      
#ifndef ERR_TRADE_TIMEOUT                               
	#define ERR_TRADE_TIMEOUT                               128             
#endif                                                                      
#ifndef ERR_INVALID_PRICE                               
	#define ERR_INVALID_PRICE                               129             
#endif                                                                      
#ifndef ERR_INVALID_STOPS                               
	#define ERR_INVALID_STOPS                               130             
#endif                                                                      
#ifndef ERR_INVALID_TRADE_VOLUME                        
	#define ERR_INVALID_TRADE_VOLUME                        131             
#endif                                                                      
#ifndef ERR_MARKET_CLOSED                               
	#define ERR_MARKET_CLOSED                               132             
#endif                                                                      
#ifndef ERR_TRADE_DISABLED                              
	#define ERR_TRADE_DISABLED                              133             
#endif                                                                      
#ifndef ERR_NOT_ENOUGH_MONEY                            
	#define ERR_NOT_ENOUGH_MONEY                            134             
#endif                                                                      
#ifndef ERR_PRICE_CHANGED                               
	#define ERR_PRICE_CHANGED                               135             
#endif                                                                      
#ifndef ERR_OFF_QUOTES                                  
	#define ERR_OFF_QUOTES                                  136             
#endif                                                                      
#ifndef ERR_BROKER_BUSY                                 
	#define ERR_BROKER_BUSY                                 137             
#endif                                                                      
#ifndef ERR_REQUOTE                                     
	#define ERR_REQUOTE                                     138             
#endif                                                                      
#ifndef ERR_ORDER_LOCKED                                
	#define ERR_ORDER_LOCKED                                139             
#endif                                                                      
#ifndef ERR_LONG_POSITIONS_ONLY_ALLOWED                 
	#define ERR_LONG_POSITIONS_ONLY_ALLOWED                 140             
#endif                                                                      
#ifndef ERR_TOO_MANY_REQUESTS                           
	#define ERR_TOO_MANY_REQUESTS                           141             
#endif                                                                      
#ifndef ERR_TRADE_MODIFY_DENIED                         
	#define ERR_TRADE_MODIFY_DENIED                         145             
#endif                                                                      
#ifndef ERR_TRADE_CONTEXT_BUSY                          
	#define ERR_TRADE_CONTEXT_BUSY                          146             
#endif                                                                      
#ifndef ERR_TRADE_EXPIRATION_DENIED                     
	#define ERR_TRADE_EXPIRATION_DENIED                     147             
#endif                                                                      
#ifndef ERR_TRADE_TOO_MANY_ORDERS                       
	#define ERR_TRADE_TOO_MANY_ORDERS                       148             
#endif                                                                      
#ifndef ERR_TRADE_HEDGE_PROHIBITED                      
	#define ERR_TRADE_HEDGE_PROHIBITED                      149             
#endif                                                                      
#ifndef ERR_TRADE_PROHIBITED_BY_FIFO                    
	#define ERR_TRADE_PROHIBITED_BY_FIFO                    150             
#endif                                                                      


/////////////////////////////////////////////////////////////////////       
//
// Return Codes of the Trade Server                                         
//                                                                          
#ifndef ERR_NO_MQLERROR                                 
	#define ERR_NO_MQLERROR                                 4000            
#endif                                                                      
#ifndef ERR_WRONG_FUNCTION_POINTER                      
	#define ERR_WRONG_FUNCTION_POINTER                      4001            
#endif                                                                      
#ifndef ERR_ARRAY_INDEX_OUT_OF_RANGE                    
	#define ERR_ARRAY_INDEX_OUT_OF_RANGE                    4002            
#endif                                                                      
#ifndef ERR_NO_MEMORY_FOR_FUNCTION_CALL_STACK           
	#define ERR_NO_MEMORY_FOR_FUNCTION_CALL_STACK           4003            
#endif                                                                      
#ifndef ERR_RECURSIVE_STACK_OVERFLOW                    
	#define ERR_RECURSIVE_STACK_OVERFLOW                    4004            
#endif                                                                      
#ifndef ERR_NOT_ENOUGH_STACK_FOR_PARAMETER              
	#define ERR_NOT_ENOUGH_STACK_FOR_PARAMETER              4005            
#endif                                                                      
#ifndef ERR_NO_MEMORY_FOR_PARAMETER_STRING              
	#define ERR_NO_MEMORY_FOR_PARAMETER_STRING              4006            
#endif                                                                      
#ifndef ERR_NO_MEMORY_FOR_TEMP_STRING                   
	#define ERR_NO_MEMORY_FOR_TEMP_STRING                   4007            
#endif                                                                      
#ifndef ERR_NOT_INITIALIZED_STRING                      
	#define ERR_NOT_INITIALIZED_STRING                      4008            
#endif                                                                      
#ifndef ERR_NOT_INITIALIZED_ARRAYSTRING                 
	#define ERR_NOT_INITIALIZED_ARRAYSTRING                 4009            
#endif                                                                      
#ifndef ERR_NO_MEMORY_FOR_ARRAYSTRING                   
	#define ERR_NO_MEMORY_FOR_ARRAYSTRING                   4010            
#endif                                                                      
#ifndef ERR_TOO_LONG_STRING                             
	#define ERR_TOO_LONG_STRING                             4011            
#endif                                                                      
#ifndef ERR_REMAINDER_FROM_ZERO_DIVIDE                  
	#define ERR_REMAINDER_FROM_ZERO_DIVIDE                  4012            
#endif                                                                      
#ifndef ERR_ZERO_DIVIDE                                 
	#define ERR_ZERO_DIVIDE                                 4013            
#endif                                                                      
#ifndef ERR_UNKNOWN_COMMAND                             
	#define ERR_UNKNOWN_COMMAND                             4014            
#endif                                                                      
#ifndef ERR_WRONG_JUMP                                  
	#define ERR_WRONG_JUMP                                  4015            
#endif                                                                      
#ifndef ERR_NOT_INITIALIZED_ARRAY                       
	#define ERR_NOT_INITIALIZED_ARRAY                       4016            
#endif                                                                      
#ifndef ERR_DLL_CALLS_NOT_ALLOWED                       
	#define ERR_DLL_CALLS_NOT_ALLOWED                       4017            
#endif                                                                      
#ifndef ERR_CANNOT_LOAD_LIBRARY                         
	#define ERR_CANNOT_LOAD_LIBRARY                         4018            
#endif                                                                      
#ifndef ERR_CANNOT_CALL_FUNCTION                        
	#define ERR_CANNOT_CALL_FUNCTION                        4019            
#endif                                                                      
#ifndef ERR_EXTERNAL_EXPERT_CALLS_NOT_ALLOWED           
	#define ERR_EXTERNAL_EXPERT_CALLS_NOT_ALLOWED           4020            
#endif                                                                      
#ifndef ERR_NOT_ENOUGH_MEMORY_FOR_RETURNED_STRING       
	#define ERR_NOT_ENOUGH_MEMORY_FOR_RETURNED_STRING       4021            
#endif                                                                      
#ifndef ERR_SYSTEM_BUSY                                 
	#define ERR_SYSTEM_BUSY                                 4022            
#endif                                                                      
#ifndef ERR_INVALID_FUNCTION_PARAMETERS_COUNT           
	#define ERR_INVALID_FUNCTION_PARAMETERS_COUNT           4050            
#endif                                                                      
#ifndef ERR_INVALID_FUNCTION_PARAMETER_VALUE            
	#define ERR_INVALID_FUNCTION_PARAMETER_VALUE            4051            
#endif                                                                      
#ifndef ERR_STRING_FUNCTION_INTERNAL_ERROR              
	#define ERR_STRING_FUNCTION_INTERNAL_ERROR              4052            
#endif                                                                      
#ifndef ERR_SOME_ARRAY_ERROR                            
	#define ERR_SOME_ARRAY_ERROR                            4053            
#endif                                                                      
#ifndef ERR_INCORRECT_SERIES_ARRAY_USING                
	#define ERR_INCORRECT_SERIES_ARRAY_USING                4054            
#endif                                                                      
#ifndef ERR_CUSTOM_INDICATOR_ERROR                      
	#define ERR_CUSTOM_INDICATOR_ERROR                      4055            
#endif                                                                      
#ifndef ERR_INCOMPATIBLE_ARRAYS                         
	#define ERR_INCOMPATIBLE_ARRAYS                         4056            
#endif                                                                      
#ifndef ERR_GLOBAL_VARIABLES_PROCESSING_ERROR           
	#define ERR_GLOBAL_VARIABLES_PROCESSING_ERROR           4057            
#endif                                                                      
#ifndef ERR_GLOBAL_VARIABLE_NOT_FOUND                   
	#define ERR_GLOBAL_VARIABLE_NOT_FOUND                   4058            
#endif                                                                      
#ifndef ERR_FUNCTION_NOT_ALLOWED_IN_TESTING_MODE        
	#define ERR_FUNCTION_NOT_ALLOWED_IN_TESTING_MODE        4059            
#endif                                                                      
#ifndef ERR_FUNCTION_NOT_CONFIRMED                      
	#define ERR_FUNCTION_NOT_CONFIRMED                      4060            
#endif                                                                      
#ifndef ERR_SEND_MAIL_ERROR                             
	#define ERR_SEND_MAIL_ERROR                             4061            
#endif                                                                      
#ifndef ERR_STRING_PARAMETER_EXPECTED                   
	#define ERR_STRING_PARAMETER_EXPECTED                   4062            
#endif                                                                      
#ifndef ERR_INTEGER_PARAMETER_EXPECTED                  
	#define ERR_INTEGER_PARAMETER_EXPECTED                  4063            
#endif                                                                      
#ifndef ERR_DOUBLE_PARAMETER_EXPECTED                   
	#define ERR_DOUBLE_PARAMETER_EXPECTED                   4064            
#endif                                                                      
#ifndef ERR_ARRAY_AS_PARAMETER_EXPECTED                 
	#define ERR_ARRAY_AS_PARAMETER_EXPECTED                 4065            
#endif                                                                      
#ifndef ERR_HISTORY_WILL_UPDATED                        
	#define ERR_HISTORY_WILL_UPDATED                        4066            
#endif                                                                      
#ifndef ERR_TRADE_ERROR                                 
	#define ERR_TRADE_ERROR                                 4067            
#endif                                                                      
#ifndef ERR_END_OF_FILE                                 
	#define ERR_END_OF_FILE                                 4099            
#endif                                                                      
#ifndef ERR_SOME_FILE_ERROR                             
	#define ERR_SOME_FILE_ERROR                             4100            
#endif                                                                      
#ifndef ERR_WRONG_FILE_NAME                             
	#define ERR_WRONG_FILE_NAME                             4101            
#endif                                                                      
#ifndef ERR_TOO_MANY_OPENED_FILES                       
	#define ERR_TOO_MANY_OPENED_FILES                       4102            
#endif                                                                      
#ifndef ERR_CANNOT_OPEN_FILE                            
	#define ERR_CANNOT_OPEN_FILE                            4103            
#endif                                                                      
#ifndef ERR_INCOMPATIBLE_ACCESS_TO_FILE                 
	#define ERR_INCOMPATIBLE_ACCESS_TO_FILE                 4104            
#endif                                                                      
#ifndef ERR_NO_ORDER_SELECTED                           
	#define ERR_NO_ORDER_SELECTED                           4105            
#endif                                                                      
#ifndef ERR_UNKNOWN_SYMBOL                              
	#define ERR_UNKNOWN_SYMBOL                              4106            
#endif                                                                      
#ifndef ERR_INVALID_PRICE_PARAM                         
	#define ERR_INVALID_PRICE_PARAM                         4107            
#endif                                                                      
#ifndef ERR_INVALID_TICKET                              
	#define ERR_INVALID_TICKET                              4108            
#endif                                                                      
#ifndef ERR_TRADE_NOT_ALLOWED                           
	#define ERR_TRADE_NOT_ALLOWED                           4109            
#endif                                                                      
#ifndef ERR_LONGS_NOT_ALLOWED                           
	#define ERR_LONGS_NOT_ALLOWED                           4110            
#endif                                                                      
#ifndef ERR_SHORTS_NOT_ALLOWED                          
	#define ERR_SHORTS_NOT_ALLOWED                          4111            
#endif                                                                      
#ifndef ERR_OBJECT_ALREADY_EXISTS                       
	#define ERR_OBJECT_ALREADY_EXISTS                       4200            
#endif                                                                      
#ifndef ERR_UNKNOWN_OBJECT_PROPERTY                     
	#define ERR_UNKNOWN_OBJECT_PROPERTY                     4201            
#endif                                                                      
#ifndef ERR_OBJECT_DOES_NOT_EXIST                       
	#define ERR_OBJECT_DOES_NOT_EXIST                       4202            
#endif                                                                      
#ifndef ERR_UNKNOWN_OBJECT_TYPE                         
	#define ERR_UNKNOWN_OBJECT_TYPE                         4203            
#endif                                                                      
#ifndef ERR_NO_OBJECT_NAME                              
	#define ERR_NO_OBJECT_NAME                              4204            
#endif                                                                      
#ifndef ERR_OBJECT_COORDINATES_ERROR                    
	#define ERR_OBJECT_COORDINATES_ERROR                    4205            
#endif                                                                      
#ifndef ERR_NO_SPECIFIED_SUBWINDOW                      
	#define ERR_NO_SPECIFIED_SUBWINDOW                      4206            
#endif                                                                      
#ifndef ERR_SOME_OBJECT_ERROR                           
	#define ERR_SOME_OBJECT_ERROR                           4207            
#endif                                                                      
#ifndef ERR_CHART_PROP_INVALID                          
	#define ERR_CHART_PROP_INVALID                          4210            
#endif                                                                      
#ifndef ERR_CHART_NOT_FOUND                             
	#define ERR_CHART_NOT_FOUND                             4211            
#endif                                                                      
#ifndef ERR_CHARTWINDOW_NOT_FOUND                       
	#define ERR_CHARTWINDOW_NOT_FOUND                       4212            
#endif                                                                      
#ifndef ERR_CHARTINDICATOR_NOT_FOUND                    
	#define ERR_CHARTINDICATOR_NOT_FOUND                    4213            
#endif                                                                      
#ifndef ERR_SYMBOL_SELECT                               
	#define ERR_SYMBOL_SELECT                               4220            
#endif                                                                      
#ifndef ERR_NOTIFICATION_ERROR                          
	#define ERR_NOTIFICATION_ERROR                          4250            
#endif                                                                      
#ifndef ERR_NOTIFICATION_PARAMETER                      
	#define ERR_NOTIFICATION_PARAMETER                      4251            
#endif                                                                      
#ifndef ERR_NOTIFICATION_SETTINGS                       
	#define ERR_NOTIFICATION_SETTINGS                       4252            
#endif                                                                      
#ifndef ERR_NOTIFICATION_TOO_FREQUENT                   
	#define ERR_NOTIFICATION_TOO_FREQUENT                   4253            
#endif                                                                      
#ifndef ERR_FTP_NOSERVER                                
	#define ERR_FTP_NOSERVER                                4260            
#endif                                                                      
#ifndef ERR_FTP_NOLOGIN                                 
	#define ERR_FTP_NOLOGIN                                 4261            
#endif                                                                      
#ifndef ERR_FTP_CONNECT_FAILED                          
	#define ERR_FTP_CONNECT_FAILED                          4262            
#endif                                                                      
#ifndef ERR_FTP_CLOSED                                  
	#define ERR_FTP_CLOSED                                  4263            
#endif                                                                      
#ifndef ERR_FTP_CHANGEDIR                               
	#define ERR_FTP_CHANGEDIR                               4264            
#endif                                                                      
#ifndef ERR_FTP_FILE_ERROR                              
	#define ERR_FTP_FILE_ERROR                              4265            
#endif                                                                      
#ifndef ERR_FTP_ERROR                                   
	#define ERR_FTP_ERROR                                   4266            
#endif                                                                      
#ifndef ERR_FILE_TOO_MANY_OPENED                        
	#define ERR_FILE_TOO_MANY_OPENED                        5001            
#endif                                                                      
#ifndef ERR_FILE_WRONG_FILENAME                         
	#define ERR_FILE_WRONG_FILENAME                         5002            
#endif                                                                      
#ifndef ERR_FILE_TOO_LONG_FILENAME                      
	#define ERR_FILE_TOO_LONG_FILENAME                      5003            
#endif                                                                      
#ifndef ERR_FILE_CANNOT_OPEN                            
	#define ERR_FILE_CANNOT_OPEN                            5004            
#endif                                                                      
#ifndef ERR_FILE_BUFFER_ALLOCATION_ERROR                
	#define ERR_FILE_BUFFER_ALLOCATION_ERROR                5005            
#endif                                                                      
#ifndef ERR_FILE_CANNOT_DELETE                          
	#define ERR_FILE_CANNOT_DELETE                          5006            
#endif                                                                      
#ifndef ERR_FILE_INVALID_HANDLE                         
	#define ERR_FILE_INVALID_HANDLE                         5007            
#endif                                                                      
#ifndef ERR_FILE_WRONG_HANDLE                           
	#define ERR_FILE_WRONG_HANDLE                           5008            
#endif                                                                      
#ifndef ERR_FILE_NOT_TOWRITE                            
	#define ERR_FILE_NOT_TOWRITE                            5009            
#endif                                                                      
#ifndef ERR_FILE_NOT_TOREAD                             
	#define ERR_FILE_NOT_TOREAD                             5010            
#endif                                                                      
#ifndef ERR_FILE_NOT_BIN                                
	#define ERR_FILE_NOT_BIN                                5011            
#endif                                                                      
#ifndef ERR_FILE_NOT_TXT                                
	#define ERR_FILE_NOT_TXT                                5012            
#endif                                                                      
#ifndef ERR_FILE_NOT_TXTORCSV                           
	#define ERR_FILE_NOT_TXTORCSV                           5013            
#endif                                                                      
#ifndef ERR_FILE_NOT_CSV                                
	#define ERR_FILE_NOT_CSV                                5014            
#endif                                                                      
#ifndef ERR_FILE_READ_ERROR                             
	#define ERR_FILE_READ_ERROR                             5015            
#endif                                                                      
#ifndef ERR_FILE_WRITE_ERROR                            
	#define ERR_FILE_WRITE_ERROR                            5016            
#endif                                                                      
#ifndef ERR_FILE_BIN_STRINGSIZE                         
	#define ERR_FILE_BIN_STRINGSIZE                         5017            
#endif                                                                      
#ifndef ERR_FILE_INCOMPATIBLE                           
	#define ERR_FILE_INCOMPATIBLE                           5018            
#endif                                                                      
#ifndef ERR_FILE_IS_DIRECTORY                           
	#define ERR_FILE_IS_DIRECTORY                           5019            
#endif                                                                      
#ifndef ERR_FILE_NOT_EXIST                              
	#define ERR_FILE_NOT_EXIST                              5020            
#endif                                                                      
#ifndef ERR_FILE_CANNOT_REWRITE                         
	#define ERR_FILE_CANNOT_REWRITE                         5021            
#endif                                                                      
#ifndef ERR_FILE_WRONG_DIRECTORYNAME                    
	#define ERR_FILE_WRONG_DIRECTORYNAME                    5022            
#endif                                                                      
#ifndef ERR_FILE_DIRECTORY_NOT_EXIST                    
	#define ERR_FILE_DIRECTORY_NOT_EXIST                    5023            
#endif                                                                      
#ifndef ERR_FILE_NOT_DIRECTORY                          
	#define ERR_FILE_NOT_DIRECTORY                          5024            
#endif                                                                      
#ifndef ERR_FILE_CANNOT_DELETE_DIRECTORY                
	#define ERR_FILE_CANNOT_DELETE_DIRECTORY                5025            
#endif                                                                      
#ifndef ERR_FILE_CANNOT_CLEAN_DIRECTORY                 
	#define ERR_FILE_CANNOT_CLEAN_DIRECTORY                 5026            
#endif                                                                      
#ifndef ERR_FILE_ARRAYRESIZE_ERROR                      
	#define ERR_FILE_ARRAYRESIZE_ERROR                      5027            
#endif                                                                      
#ifndef ERR_FILE_STRINGRESIZE_ERROR                     
	#define ERR_FILE_STRINGRESIZE_ERROR                     5028            
#endif                                                                      
#ifndef ERR_FILE_STRUCT_WITH_OBJECTS                    
	#define ERR_FILE_STRUCT_WITH_OBJECTS                    5029            
#endif                                                                      
#ifndef ERR_WEBREQUEST_INVALID_ADDRESS                  
	#define ERR_WEBREQUEST_INVALID_ADDRESS                  5200            
#endif                                                                      
#ifndef ERR_WEBREQUEST_CONNECT_FAILED                   
	#define ERR_WEBREQUEST_CONNECT_FAILED                   5201            
#endif                                                                      
#ifndef ERR_WEBREQUEST_TIMEOUT                          
	#define ERR_WEBREQUEST_TIMEOUT                          5202            
#endif                                                                      
#ifndef ERR_WEBREQUEST_REQUEST_FAILED					
	#define ERR_WEBREQUEST_REQUEST_FAILED					5203
#endif




/**********************************************************************************/
#endif // LIB_ERRDEFINITIONS_MQH_INCLUDED